Subject: Re: [PATCH v3 14/21] read-cache: touch shared index files when used

From: Junio C Hamano <[email-masked]>
Date: Thu, 19 Jan 2017 11:00:20 -0800

Duy Nguyen <[email-masked]> writes:

> On Mon, Jan 9, 2017 at 9:34 PM, Junio C Hamano <[email-masked]> wrote:
>> Duy Nguyen <[email-masked]> writes:
>>
>>> On Sun, Jan 8, 2017 at 4:46 AM, Junio C Hamano <[email-masked]> wrote:
>>>> Christian Couder <[email-masked]> writes:
>>>>
>>>>> So what should we do if freshen_file() returns 0 which means that the
>>>>> freshening failed?
>>>>
>>>> You tell me ;-)  as you are the one who is proposing this feature.
>>>
>>> My answer is, we are not worse than freshening loose objects case
>>> (especially since I took the idea from there).
>>
>> I do not think so, unfortunately.  Loose object files with stale
>> timestamps are not removed as long as objects are still reachable.
>
> But there are plenty of unreachable loose objects, added in index,
> then got replaced with new versions. cache-tree can create loose trees
> too and it's been run more often, behind user's back, to take
> advantage of the shortcut in unpack-trees.

I am not sure if I follow.  Aren't objects reachable from the
cache-tree in the index protected from gc?

Not that I think freshening would actually fail in a repository
where you can actually write into to update the index or its refs to
make a difference (iow, even if we make it die() loudly when shared
index cannot be "touched" because we are paranoid, no real life
usage will trigger that die(), and if a repository does trigger the
die(), I think you would really want to know about it).